# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.open_gl_render_window import OpenGLRenderWindow


class CocoaRenderWindow(OpenGLRenderWindow):
    r"""
    CocoaRenderWindow - Cocoa open_gl rendering window
    
    Superclass: OpenGLRenderWindow
    
    CocoaRenderWindow is a concrete implementation of the abstract
    class OpenGLRenderWindow. It is only available on Mac OS X. To use
    this class, build VTK with VTK_USE_COCOA turned ON (this is the
    default). This class can be used by 32 and 64 bit processes, and
    either in garbage collected or reference counted modes. ARC is not
    yet supported. CocoaRenderWindow uses Objective-C++, and the
    open_gl and Cocoa APIs. This class's default behaviour is to create an
    NSWindow and a CocoaGLView which are used together to draw all VTK
    content. If you already have an NSWindow and CocoaGLView and you
    want this class to use them you must call both set_root_window() and
    set_window_id(), respectively, early on (before window_initialize() is
    executed).
    
    @sa
    OpenGLRenderWindow CocoaGLView
    
    @warning
    This header must be in C++ only because it is included by .cxx files.
    That means no Objective-C may be used. That's why some instance
    variables are void* instead of what they really should be.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkCocoaRenderWindow, obj, update, **traits)
    
    connect_context_to_ns_view = traits.Bool(True, enter_set=True, auto_set=False, desc=\
        r"""
        Set to false if you want to prevent the NSopen_gl_context from
        being associated with the NSView. You might want this is you are
        rendering vtk content into a CAopen_gl_layer instead of an NSView.
        Defaults to true.
        """
    )

    def _connect_context_to_ns_view_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetConnectContextToNSView,
                        self.connect_context_to_ns_view)

    def _get_context_id(self):
        return self._vtk_obj.GetContextId()
    def _set_context_id(self, arg):
        old_val = self._get_context_id()
        self._wrap_call(self._vtk_obj.SetContextId,
                        arg)
        self.trait_property_changed('context_id', old_val, arg)
    context_id = traits.Property(_get_context_id, _set_context_id, desc=\
        r"""
        
        """
    )

    current_cursor = traits.Int(0, enter_set=True, auto_set=False, desc=\
        r"""
        Change the shape of the cursor.
        """
    )

    def _current_cursor_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetCurrentCursor,
                        self.current_cursor)

    def _get_parent_id(self):
        return self._vtk_obj.GetParentId()
    def _set_parent_id(self, arg):
        old_val = self._get_parent_id()
        self._wrap_call(self._vtk_obj.SetParentId,
                        arg)
        self.trait_property_changed('parent_id', old_val, arg)
    parent_id = traits.Property(_get_parent_id, _set_parent_id, desc=\
        r"""
        Get the parent NSView* for this RenderWindow.  This method
        will return "NULL" if the parent was not set with set_parent_id()
        or set_parent_info().
        """
    )

    def _get_pixel_format(self):
        return self._vtk_obj.GetPixelFormat()
    def _set_pixel_format(self, arg):
        old_val = self._get_pixel_format()
        self._wrap_call(self._vtk_obj.SetPixelFormat,
                        arg)
        self.trait_property_changed('pixel_format', old_val, arg)
    pixel_format = traits.Property(_get_pixel_format, _set_pixel_format, desc=\
        r"""
        
        """
    )

    position = traits.Array(enter_set=True, auto_set=False, shape=(None,), dtype="int", value=(0, 0), cols=2, desc=\
        r"""
        Set the position (x and y) of the rendering window in screen
        coordinates (in pixels). This resizes the operating system's
        view/window and redraws it.
        """
    )

    def _position_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetPosition,
                        self.position)

    def _get_root_window(self):
        return self._vtk_obj.GetRootWindow()
    def _set_root_window(self, arg):
        old_val = self._get_root_window()
        self._wrap_call(self._vtk_obj.SetRootWindow,
                        arg)
        self.trait_property_changed('root_window', old_val, arg)
    root_window = traits.Property(_get_root_window, _set_root_window, desc=\
        r"""
        Returns the NSWindow* associated with this RenderWindow.
        """
    )

    size = traits.Array(enter_set=True, auto_set=False, shape=(None,), dtype="int", value=(0, 0), cols=2, desc=\
        r"""
        Set the size (width and height) of the rendering window in screen
        coordinates (in pixels). This resizes the operating system's
        view/window and redraws it.
        
        If the size has changed, this method will fire
        Command::WindowResizeEvent.
        """
    )

    def _size_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetSize,
                        self.size)

    wants_best_resolution = traits.Bool(True, enter_set=True, auto_set=False, desc=\
        r"""
        Set to true if you want to force NSViews created by this object
        to have their wantsbest_resolution_open_gl_surface property set to
        YES. Otherwise, the bundle's Info.plist will be checked for the
        "NShigh_resolution_capable" key, if it is present and YES,
        wantsbest_resolution_open_gl_surface will be set to YES. In all other
        cases, setwants_best_resolution_open_gl_surface: is not invoked at
        all. Notably, setwants_best_resolution_open_gl_surface: is never
        invoked on NSViews not created by VTK itself.
        """
    )

    def _wants_best_resolution_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetWantsBestResolution,
                        self.wants_best_resolution)

    def _get_window_id(self):
        return self._vtk_obj.GetWindowId()
    def _set_window_id(self, arg):
        old_val = self._get_window_id()
        self._wrap_call(self._vtk_obj.SetWindowId,
                        arg)
        self.trait_property_changed('window_id', old_val, arg)
    window_id = traits.Property(_get_window_id, _set_window_id, desc=\
        r"""
        Returns the NSView* associated with this RenderWindow.
        """
    )

    window_name = traits.String('Visualization Toolkit - Cocoa', enter_set=True, auto_set=False, desc=\
        r"""
        Set the name of the window. This appears at the top of the window
        normally.
        """
    )

    def _window_name_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetWindowName,
                        self.window_name)

    def _get_view_created(self):
        return self._vtk_obj.GetViewCreated()
    view_created = traits.Property(_get_view_created, desc=\
        r"""
        Get the view_created flag. It is 1 if this object created an
        instance of NSView, 0 otherwise.
        """
    )

    def _get_window_created(self):
        return self._vtk_obj.GetWindowCreated()
    window_created = traits.Property(_get_window_created, desc=\
        r"""
        Get the window_created flag. It is 1 if this object created an
        instance of NSWindow, 0 otherwise.
        """
    )

    def pref_full_screen(self):
        """
        pref_full_screen(self) -> None
        C++: virtual void pref_full_screen()
        Set the preferred window size to full screen.  This is not
        implemented for the CocoaRenderWindow.
        """
        ret = self._vtk_obj.PrefFullScreen()
        return ret
        

    def setup_palette(self, *args):
        """
        setup_palette(self, hDC:Pointer) -> None
        C++: virtual void setup_palette(void *hDC)
        Initialize open_gl for this window.
        """
        ret = self._wrap_call(self._vtk_obj.SetupPalette, *args)
        return ret

    def setup_pixel_format(self, *args):
        """
        setup_pixel_format(self, hDC:Pointer, dwFlags:Pointer, debug:int,
            bpp:int=16, zbpp:int=16) -> None
        C++: virtual void setup_pixel_format(void *hDC, void *dwFlags,
            int debug, int bpp=16, int zbpp=16)"""
        ret = self._wrap_call(self._vtk_obj.SetupPixelFormat, *args)
        return ret

    def update_context(self):
        """
        update_context(self) -> None
        C++: void update_context()
        Update this window's open_gl context, e.g. when the window is
        resized.
        """
        ret = self._vtk_obj.UpdateContext()
        return ret
        

    def window_configure(self):
        """
        window_configure(self) -> None
        C++: virtual void window_configure()
        Specify various window parameters.
        """
        ret = self._vtk_obj.WindowConfigure()
        return ret
        

    _updateable_traits_ = \
    (('framebuffer_flip_y', 'GetFramebufferFlipY'), ('borders',
    'GetBorders'), ('enable_translucent_surface',
    'GetEnableTranslucentSurface'), ('full_screen', 'GetFullScreen'),
    ('line_smoothing', 'GetLineSmoothing'), ('point_smoothing',
    'GetPointSmoothing'), ('polygon_smoothing', 'GetPolygonSmoothing'),
    ('stencil_capable', 'GetStencilCapable'), ('stereo_capable_window',
    'GetStereoCapableWindow'), ('stereo_render', 'GetStereoRender'),
    ('swap_buffers', 'GetSwapBuffers'), ('use_srgb_color_space',
    'GetUseSRGBColorSpace'), ('double_buffer', 'GetDoubleBuffer'),
    ('erase', 'GetErase'), ('off_screen_rendering',
    'GetOffScreenRendering'), ('show_window', 'GetShowWindow'),
    ('use_off_screen_buffers', 'GetUseOffScreenBuffers'), ('debug',
    'GetDebug'), ('global_warning_display', 'GetGlobalWarningDisplay'),
    ('frame_blit_mode', 'GetFrameBlitMode'), ('stereo_type',
    'GetStereoType'), ('connect_context_to_ns_view',
    'GetConnectContextToNSView'), ('current_cursor', 'GetCurrentCursor'),
    ('position', 'GetPosition'), ('size', 'GetSize'),
    ('wants_best_resolution', 'GetWantsBestResolution'), ('window_name',
    'GetWindowName'), ('global_maximum_number_of_multi_samples',
    'GetGlobalMaximumNumberOfMultiSamples'),
    ('render_buffer_target_depth_size', 'GetRenderBufferTargetDepthSize'),
    ('abort_render', 'GetAbortRender'), ('alpha_bit_planes',
    'GetAlphaBitPlanes'), ('anaglyph_color_mask', 'GetAnaglyphColorMask'),
    ('anaglyph_color_saturation', 'GetAnaglyphColorSaturation'),
    ('cursor_file_name', 'GetCursorFileName'), ('desired_update_rate',
    'GetDesiredUpdateRate'), ('device_index', 'GetDeviceIndex'),
    ('in_abort_check', 'GetInAbortCheck'), ('multi_samples',
    'GetMultiSamples'), ('number_of_layers', 'GetNumberOfLayers'),
    ('physical_scale', 'GetPhysicalScale'), ('physical_translation',
    'GetPhysicalTranslation'), ('physical_view_direction',
    'GetPhysicalViewDirection'), ('physical_view_up',
    'GetPhysicalViewUp'), ('dpi', 'GetDPI'), ('tile_scale',
    'GetTileScale'), ('tile_viewport', 'GetTileViewport'), ('object_name',
    'GetObjectName'), ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['borders', 'debug', 'double_buffer', 'enable_translucent_surface',
    'erase', 'framebuffer_flip_y', 'full_screen',
    'global_warning_display', 'line_smoothing', 'off_screen_rendering',
    'point_smoothing', 'polygon_smoothing', 'show_window',
    'stencil_capable', 'stereo_capable_window', 'stereo_render',
    'swap_buffers', 'use_off_screen_buffers', 'use_srgb_color_space',
    'frame_blit_mode', 'stereo_type', 'abort_render', 'alpha_bit_planes',
    'anaglyph_color_mask', 'anaglyph_color_saturation',
    'connect_context_to_ns_view', 'current_cursor', 'cursor_file_name',
    'desired_update_rate', 'device_index', 'dpi',
    'global_maximum_number_of_multi_samples', 'in_abort_check',
    'multi_samples', 'number_of_layers', 'object_name', 'physical_scale',
    'physical_translation', 'physical_view_direction', 'physical_view_up',
    'position', 'render_buffer_target_depth_size', 'size', 'tile_scale',
    'tile_viewport', 'wants_best_resolution', 'window_name'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(CocoaRenderWindow, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit CocoaRenderWindow properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['borders', 'double_buffer', 'enable_translucent_surface',
            'erase', 'framebuffer_flip_y', 'full_screen', 'line_smoothing',
            'off_screen_rendering', 'point_smoothing', 'polygon_smoothing',
            'show_window', 'stencil_capable', 'stereo_capable_window',
            'stereo_render', 'swap_buffers', 'use_off_screen_buffers',
            'use_srgb_color_space'], ['frame_blit_mode', 'stereo_type'],
            ['abort_render', 'alpha_bit_planes', 'anaglyph_color_mask',
            'anaglyph_color_saturation', 'connect_context_to_ns_view',
            'current_cursor', 'cursor_file_name', 'desired_update_rate',
            'device_index', 'dpi', 'global_maximum_number_of_multi_samples',
            'in_abort_check', 'multi_samples', 'number_of_layers', 'object_name',
            'physical_scale', 'physical_translation', 'physical_view_direction',
            'physical_view_up', 'position', 'render_buffer_target_depth_size',
            'size', 'tile_scale', 'tile_viewport', 'wants_best_resolution',
            'window_name']),
            title='Edit CocoaRenderWindow properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit CocoaRenderWindow properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

